//
//  RCDHtmlTextMessageCell.m
//  RongIMKit_Demo
//
//  Created by Jue on 2019/10/23.
//  Copyright © 2019 RC. All rights reserved.
//

#import "RCDHtmlTextMessageCell.h"
#import <objc/runtime.h>

static void *kHasHTMLTag = &kHasHTMLTag;

@implementation RCDHtmlTextMessageCell

+ (CGSize)sizeForMessageModel:(RCMessageModel *)model
  withCollectionViewWidth:(CGFloat)collectionViewWidth
     referenceExtraHeight:(CGFloat)extraHeight {

CGSize superSize = [super sizeForMessageModel:model withCollectionViewWidth:collectionViewWidth referenceExtraHeight:extraHeight];

    return superSize;
}

- (void)setDataModel:(RCMessageModel *)model {
    RCTextMessage *messageContent = (RCTextMessage *)model.content;
    if ([self hasHTMLTag:messageContent.content]) {
        messageContent.content = [self fixHTML:messageContent.content];
        [super setDataModel:model];
    } else {
        [super setDataModel:model];
    }
}

- (BOOL)hasHTMLTag:(NSString *)content {
    if (!content.length) {
        return NO;
    }
    NSNumber *ret;
    if ((ret = objc_getAssociatedObject(self, kHasHTMLTag))) {
        return [ret boolValue];
    }

    NSRegularExpression *regex =
            [NSRegularExpression regularExpressionWithPattern:
             @"<(img|br|p|a)[^>]+>|</?p>|<b>|</b>|<div>|</div>|<br>|<p>|</p>|<span>|</span>|<a>"
                                                      options:NSRegularExpressionCaseInsensitive
                                                        error:nil];
    NSTextCheckingResult *match = [regex firstMatchInString:content
                                                    options:NSMatchingReportCompletion
                                                      range:NSMakeRange(0, content.length)];
    ret = [NSNumber numberWithBool:match ? YES : NO];
    objc_setAssociatedObject(self, kHasHTMLTag, ret, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
    return [ret boolValue];
}

- (NSString *)fixHTML:(NSString *)content {
    
    NSString *tmp = [content stringByReplacingOccurrencesOfString:@"<p>"withString:@""];

    //p标签转换行
    tmp = [tmp stringByReplacingOccurrencesOfString:@"<br/>"withString:@""];
    tmp = [tmp stringByReplacingOccurrencesOfString:@"</p>"withString:@" <br/>"];

    //去除字符串最后的<br/>
    NSString *ss;
    if (tmp.length >= 5) {
ss = [tmp substringWithRange:NSMakeRange(tmp.length -5 , 5)];
    }
    if ([ss isEqualToString:@"<br/>"]) {
        tmp = [tmp substringToIndex:tmp.length -5];
    }

    return tmp;
}

@end
